 /* eslint-disable */
 (() => {
    "use strict";

    // History || Page change event listeners
    history.pushState = (f =>
      function pushState() {
        var ret = f.apply(this, arguments);
        window.dispatchEvent(new Event("pushState"));
        window.dispatchEvent(new Event("locationchange"));
        return ret;
      })(history.pushState);

    history.replaceState = (f =>
      function replaceState() {
        var ret = f.apply(this, arguments);
        window.dispatchEvent(new Event("replaceState"));
        window.dispatchEvent(new Event("locationchange"));
        return ret;
      })(history.replaceState);

    window.addEventListener("popstate", () => {
      window.dispatchEvent(new Event("locationchange"));
    });


    const options = window.defaultAppOptions || {
      title: {
        inner: ""
      },
      meta: [],
      link: [],
      script: [],
      style: []
    };

    const shield = new Shield(options);

    window.addEventListener("locationchange", function() {
      const path =
        document.location.pathname + document.location.hash.split("?")[0];
      if (pageConfig[path]) {
        shield.update(pageConfig[path]);
      }
    });

    const pageConfig = window.pageConfig || {};

    // TODO: remove timeout amd observe for page load event
    // by listening to dom change event
    document.addEventListener("DOMContentLoaded", function(event) {
      setTimeout(function() {
        shield.init();
        const path =
          document.location.pathname + document.location.hash.split("?")[0];
        if (pageConfig[path]) {
          shield.update(pageConfig[path]);
        }
      }, 1000);
    });

  })();